#!/usr/bin/python
from wxPython.wx import *
import math

RAD=30   #Radius of genus
XCENT=110  #Center of Template 
YCENT=100
END=300
ARDIV=7 #Arrow diamater relative to radius (RAD/ARDIV)
PENS=3 #Normal pen size
APENS=3 #Arrow pen size
ARXMULT=3 #Arrow length relative ARDIV

ID_ABOUT=101
ID_EXIT=110

class ButtonFrame(wxFrame):
    def __init__(self):
        self.RAD=30
        wxFrame.__init__(self,NULL,-1,'legoL Release 1.0, Nonlinear Dynamics Group @ Drexel (Jones)',wxDefaultPosition,(470,400))
        sizer=wxBoxSizer(wxVERTICAL)
        button=wxButton(self,111,'Generate Template')
        sizer.Add(button ,2,wxALL|wxALIGN_RIGHT,1)
        button3=wxButton(self,112,'Quit Playing legoL')
        sizer.Add(button3 ,2,wxALL|wxALIGN_RIGHT,2)
        dd=wxPaintDC(self)
        group      = wxStaticBox(self, 11)
        self.box   = wxStaticBoxSizer(group)
        self.box.Add(self, 1, 4)

        i = wxImage("logo.gif", wxBITMAP_TYPE_GIF)
        ii=wxImage("logo2.gif",wxBITMAP_TYPE_GIF)
        b = wxBitmapFromImage(i)
        bb=wxBitmapFromImage(ii)
        sb = wxStaticBitmap(self, -1,b,(0,0))
        sb2= wxStaticBitmap(self, -1,bb,(250,165))

        self.quote = wxStaticText(self, -1, "Template Generation Program: Enter Template Type:",wxPoint(10, 100))
        self.logger = wxTextCtrl(self,5, "",wxPoint(180,130), wxSize(160,20),wxTE_MULTILINE | wxTE_READONLY)
        self.sampleList = ['---Select one---','Linear','Cyclic']#,'Dog Bone','Broken Dog Bone (Right)','Broken Dog Bone (Left)']
        self.edithear=wxComboBox(self, 30, "", wxPoint(10, 130), wxSize(160, -1),self.sampleList, wxCB_DROPDOWN)
        EVT_COMBOBOX(self, 30, self.EvtComboBox)

        self.quote = wxStaticText(self, -1, "Enter circular hole count:",wxPoint(10, 160))
        self.logger2 = wxTextCtrl(self,5, "",wxPoint(120,190), wxSize(100,20),wxTE_MULTILINE | wxTE_READONLY)
        self.sampleList2 = ['---','2','3','4','5','6','7','8','9','10']
        self.edithear2=wxComboBox(self, 31, "", wxPoint(10, 190), wxSize(95, -1),self.sampleList2, wxCB_DROPDOWN)
        N=0
        EVT_COMBOBOX(self, 31, self.EvtComboBox2)

        self.quote = wxStaticText(self, -1, "Do you wish your template to be labeled?",wxPoint(10, 225))
        self.radioList = ['Yes','No']
        self.radioList2 = ['Yes','No']
        rb = wxRadioBox(self, 50,"Alphabetical?", wxPoint(10, 250), wxDefaultSize, self.radioList,2, wxRA_SPECIFY_COLS)
        rb2 = wxRadioBox(self, 51,"Numerical?", wxPoint(130, 250), wxDefaultSize, self.radioList2,2,wxRA_SPECIFY_COLS)
        EVT_RADIOBOX(self, 50, self.EvtRadioBox)
        EVT_RADIOBOX(self, 51, self.EvtRadioBox2)

        self.quote = wxStaticText(self, -1, "Enter Label Font Size If Needed:",wxPoint(10, 305))
        self.logger22 = wxTextCtrl(self,511, "",wxPoint(120,325), wxSize(100,20),wxTE_MULTILINE | wxTE_READONLY)
        self.sampleList22 = ['---','8','9','10','11','12','13','14','15','16','17','18','19','20','21','22']
        self.edithear22=wxComboBox(self, 511, "", wxPoint(10, 325), wxSize(95, -1),self.sampleList22, wxCB_DROPDOWN)
        N=0

        self.quote = wxStaticText(self, -1, "To save the template image, left click with",wxPoint(10, 360))
        self.quote = wxStaticText(self, -1, "your mouse on the image > output.bmp",wxPoint(10, 373))
        EVT_COMBOBOX(self, 511, self.EvtComboBox22)
        
        
        EVT_BUTTON(self,111,self.onButton)
        EVT_BUTTON(self,112,self.onButton2)
        self.SetAutoLayout(1)
        self.SetSizer(sizer)
        DrawPanel.ALPHA=0
        DrawPanel.FONTY=10
        DrawPanel.NUMBER=0
        #dd.EndDrawing()
    def EvtComboBox(self,event):
        self.logger.Clear()
        self.logger.AppendText('%s' % event.GetString())
        FORM=event.GetString()
        DrawPanel.TYPE=FORM
        
    def EvtComboBox2(self,event):
        self.logger2.Clear()
        #self.logger2.AppendText('%s' % event.GetString())
        FORM=event.GetString()
        DrawPanel.N=FORM
        self.RAD=event.GetInt()*200 + 150#+ (8-event.GetInt()*100)
        self.logger2.AppendText('%s' % DrawPanel.N)


    def EvtComboBox22(self,event):
        self.logger22.Clear()
        #self.logger2.AppendText('%s' % event.GetString())
        DrawPanel.FONTY=event.GetInt()+7
        self.logger22.AppendText('%s' % DrawPanel.FONTY)

    def EvtRadioBox(self, event):
        DrawPanel.ALPHA=event.GetInt()
    def EvtRadioBox2(self,event):
        DrawPanel.NUMBER=event.GetInt()
#        self.logger.AppendText('%d:' % event.GetInt())
        
         
    def onButton(self,event):
        app2 = wxPySimpleApp()
        mul=0.95
        mul2=0
        if (DrawPanel.TYPE=='Cyclic'):
            mul=0
            mul2=1
        frame = wxFrame( None, -1, "legoLs, CopyLeft 2005 NLD@Drexel",size=(500*mul2 + mul*self.RAD+50,400*mul2 +200*mul) )
        DrawPanel( frame )
        frame.Show(1)
        app2.MainLoop()
    def onButton2(self,event):
        self.Destroy()
        

#    def SAVE(self,event=None):
 #      s=3
  #     context = wxClientDC( DrawPanel ) 
   #    memory = wxMemoryDC( ) 
    #   x,y = self.GetClientSizeTuple() 
#       bitmap = wxEmptyBitmap( x,y, -1 ) 
 #      memory.SelectObject( bitmap ) 
  #     memory.Blit( 0,0,x,y, context, 0,0) 
   #    memory.SelectObject( wxNullBitmap) 
       #bitmap.SaveFile( "test.bmp", wxBITMAP_TYPE_BMP ) 
    #   bitmap.SaveFile( "output.gif", wxBITMAP_TYPE_GIF )

    
class DrawPanel( wxPanel ):
    def __init__(self,parent):
        wxPanel.__init__(self,parent,-1)
        EVT_PAINT( self, self.OnPaintLEFT )

        
    def OnPaintLEFT(self, event=None ):
        #wxBell()
        dc = wxPaintDC( self )
        dc.Clear()
        N=int(self.N)
        #N=4;
        M=6*N-2-4  #Length -4 for edges
        MY=4 #Y LENGTH NET
        ALPHA=self.ALPHA
        NUMBER=self.NUMBER


#        if(self.TYPE=='Broken Dog Bone (Right)'):

        
        if(self.TYPE=='Cyclic'):
            dc.SetPen( wxPen("BLACK",PENS) )
            if(N==4):dc.SetPen( wxPen("BLACK",PENS+1) )
            if(N==7):dc.SetPen( wxPen("BLACK",PENS+1) )
            XC = XCENT + 5*RAD
            YC = YCENT+100
            degs =math.pi/180
            angs=360/N
            start=-90
            for I1 in range(N):dc.DrawCircle(XC+3*RAD*math.cos((start+I1*angs)*degs),YC+3*RAD*math.sin((start+I1*angs)*degs),2*RAD)
            #BREAKS THEM UP
            MaBrush=wxBrush("WHITE",wxSOLID)
            dc.SetPen(wxPen("WHITE",0))
            SR=math.sqrt(17*RAD*RAD+8*RAD*RAD*math.cos((angs/2)*degs))
            if(N<7): dc.DrawCircle(XC,YC,SR*0.99)
            if(N==7): dc.DrawCircle(XC,YC,SR*0.98)
            if(N>7): dc.DrawCircle(XC,YC,SR*0.99)
            #CONNECT THEM NOW
            dc.SetPen( wxPen("BLACK",PENS) )
            ANG=math.asin(2*RAD*math.cos(((angs)/2)*degs)/SR)
            PHI=ANG/degs
            theta = -90
            SRR=SR*1#*0.999
            AMM=math.asin(2*(RAD*math.sin((angs/2)*degs))/SR) #IS IN RADS!
            AM=AMM*0.85
            if(N==7):dc.SetPen( wxPen("BLACK",PENS+1) )
            if(N==2):AM=AMM*0.946
            if(N==3):AM=AMM*0.86
            if(N==7):AM=AMM*0.86

            for I1 in range(N):
                theta=theta + 360/N
                XCC=XC+SRR*math.cos(theta*degs +AM)
                YCC=YC+SRR*math.sin(theta*degs +AM)
                XCCC=XC+SRR*math.cos((theta + 360/N)*degs+-AM)
                YCCC=YC+SRR*math.sin((theta+360/N)*degs+-AM)
                dc.DrawLine(XCC,YCC,XCCC,YCCC)
                if(N==3):
                    dc.SetPen( wxPen("WHITE",4) )
                    SRRR=SRR + RAD+15
                    if(I1==2):SRRR=SRR+RAD+14
                    XCC=XC+SRRR*math.cos(theta*degs +AM-13*degs)
                    YCC=YC+SRRR*math.sin(theta*degs +AM-13*degs)
                    XCCC=XC+SRRR*math.cos((theta + 360/N)*degs+-AM+13*degs)
                    YCCC=YC+SRRR*math.sin((theta+360/N)*degs+-AM+13*degs)
                    dc.DrawLine(XCC,YCC,XCCC,YCCC)
                    dc.SetPen( wxPen("BLACK",PENS) )
            if(N==2):dc.DrawText('Don\'t use this form, use the linear form.',10,10)
            if(N==7):  #Cosmetic crap for 7
                    dc.SetPen( wxPen("WHITE",4) )
                    SRRR=SRR + RAD - 28
                    if(I1==2):SRRR=SRR+RAD+14
                    XCC=XC+SRRR*math.cos(theta*degs +AM+3*degs)#tilt forward from tp
                    YCC=YC+SRRR*math.sin(theta*degs +AM)
                    XCCC=XC+SRRR*math.cos((theta + 360/N)*degs+-AM)
                    YCCC=YC+SRRR*math.sin((theta+360/N)*degs+-AM)
                    dc.DrawLine(XCC,YCC,XCCC,YCCC)
                    XCC=XC+SRRR*math.cos((theta+3*360/N)*degs +AM)#tilt forward from tp
                    YCC=YC+SRRR*math.sin((theta+3*360/N)*degs +AM+5*degs)
                    XCCC=XC+SRRR*math.cos((theta + 4*360/N)*degs+-AM+2*degs)
                    YCCC=YC+SRRR*math.sin((theta+4*360/N)*degs+-AM)
                    dc.DrawLine(XCC,YCC,XCCC,YCCC)
                    XCC=XC+SRRR*1.206*math.cos((theta+0*360/N)*degs +AM+7*degs)#tilt forward from tp
                    YCC=YC+SRRR*1.206*math.sin((theta+0*360/N)*degs +AM)
                    XCCC=XC+SRRR*1.206*math.cos((theta -1*360/N)*degs+-AM)
                    YCCC=YC+SRRR*1.206*math.sin((theta-1*360/N)*degs+-AM)
                    dc.DrawLine(XCC,YCC,XCCC,YCCC)
                    dc.SetPen( wxPen("BLACK",PENS) )
                      #That was hard, next draw regular circles:
                
            for I1 in range(N):
                dc.DrawCircle(XC+3*RAD*math.cos((start+I1*angs)*degs),YC+3*RAD*math.sin((start+I1*angs)*degs),RAD-N)
                dc.DrawLine(XC+(4*RAD-N)*math.cos((start+I1*angs)*degs),YC+(4*RAD-N)*math.sin((start+I1*angs)*degs),XC+(5*RAD)*math.cos((start+I1*angs)*degs),YC+(5*RAD)*math.sin((start+I1*angs)*degs))

            #TEXT~
            OFF=self.FONTY
            font = wxFont(OFF*2,wxSWISS,wxNORMAL,wxBOLD)
            dc.SetFont(font)
            if(ALPHA<1):

                for I1 in range(N):
                    TX=XC+3*RAD*math.cos((start+I1*angs)*degs)-4
                    TY=YC+3*RAD*math.sin((start+I1*angs)*degs)-5
                    if(I1==0):dc.DrawText("A",TX-OFF/2,TY-OFF)
                    if(I1==1):dc.DrawText("B",TX-OFF/2,TY-OFF)
                    if(I1==2):dc.DrawText("C",TX-OFF/2,TY-OFF)
                    if(I1==3):dc.DrawText("D",TX-OFF/2,TY-OFF)
                    if(I1==4):dc.DrawText("E",TX-OFF/2,TY-OFF)
                    if(I1==5):dc.DrawText("F",TX-OFF/2,TY-OFF)
                    if(I1==6):dc.DrawText("G",TX-OFF/2,TY-OFF)
                    if(I1==7):dc.DrawText("H",TX-OFF/2,TY-OFF)
                    if(I1==8):dc.DrawText("I",TX-OFF/2,TY-OFF)
                    if(I1==9):dc.DrawText("J",TX-OFF/2,TY-OFF)
                    if(I1==10):dc.DrawText("K",TX-OFF/2,TY-OFF)
            if(NUMBER<1):
                for I1 in range(N):
                    TX=XC+5.8*RAD*math.cos((start+I1*angs)*degs)-4
                    TY=YC+5.8*RAD*math.sin((start+I1*angs)*degs)-5
                    if(I1==0):dc.DrawText("1",TX-OFF/2,TY-OFF)
                    if(I1==1):dc.DrawText("2",TX-OFF/2,TY-OFF)
                    if(I1==2):dc.DrawText("3",TX-OFF/2,TY-OFF)
                    if(I1==3):dc.DrawText("4",TX-OFF/2,TY-OFF)
                    if(I1==4):dc.DrawText("5",TX-OFF/2,TY-OFF)
                    if(I1==5):dc.DrawText("6",TX-OFF/2,TY-OFF)
                    if(I1==6):dc.DrawText("7",TX-OFF/2,TY-OFF)
                    if(I1==7):dc.DrawText("8",TX-OFF/2,TY-OFF)
                    if(I1==8):dc.DrawText("9",TX-OFF/2,TY-OFF)
                    if(I1==9):dc.DrawText("10",TX-OFF/2,TY-OFF)




            AM=180/N
            SRR=1.5*RAD
            theta=0
            pts=[]
            ##INNER POLYGON
            theta=0
            for I1 in range(N):
                theta=theta + 360/N
                if(N==2):
                    if(I1==0):theta=90/N
                if(N==4):
                    if(I1==0):theta=90/N
                if(N==6):
                    if(I1==0):theta=90/N
                if(N==8):
                    if(I1==0):theta=90/N
                if(N==10):
                    if(I1==0):theta=90/N

                XCC=XC+SRR*math.cos(theta*degs)
                YCC=YC+SRR*math.sin(theta*degs)
                XCCC=XC+SRR*math.cos((theta + 180/N)*degs)
                YCCC=YC+SRR*math.sin((theta+180/N)*degs)
                # dc.DrawLine(XCC,YCC,XCCC,YCCC)
                #dc.DrawLine(XCC,YCC,XCCCC,YCCCC)
                pts.append((XCC,YCC))
                pts.append((XCCC,YCCC))
            dc.DrawPolygon(pts)
            ##ARROWS
            theta=0
            SRR=1.5*RAD-(10-N)*1
            for I1 in range(N):
                pts=[]
                dc.SetPen( wxPen("BLACK",1) )
                theta=theta + 360/N
                if(N==3):
                   if(I1==0):theta=90/N
                if(N==5):
                    if(I1==0):theta=90/N
                if(N==7):
                    if(I1==0):theta=90/N
                if(N==9):
                    if(I1==0):theta=90/N
                XCC=XC+SRR*0.9*math.cos(theta*degs)
                YCC=YC+SRR*0.9*math.sin(theta*degs)
                XCC2=XC+SRR*1.2*math.cos(theta*degs)
                YCC2=YC+SRR*1.2*math.sin(theta*degs)
                XCCC=XC+SRR*1.1*math.cos((theta- 23)*degs)
                YCCC=YC+SRR*1.1*math.sin((theta- 23)*degs)
                #dc.DrawLine(XC,YC,XCC,YCC)
#                dc.SetPen( wxPen("RED",PENS) )
               # dc.DrawLine(XC,YC,XCCC,YCCC)
                #dc.DrawLine(XCC,YCC,XCCCC,YCCCC)
                pts.append((XCC,YCC))
                pts.append((XCC2,YCC2))
                pts.append((XCCC,YCCC))
                MaBrush=wxBrush("BLACK",wxSOLID)
                dc.SetBrush(MaBrush)
                dc.DrawPolygon(pts)
                dc.SetPen(wxPen("BLACK",1))

        ###OUTER THEN INNER ARROWS

            theta = 180/N
            for I1 in range(N):
                pts=[]
                dc.SetPen( wxPen("BLACK",1) )
                theta=theta + 360/N
                if(N==3):
                   if(I1==0):theta=270/N
                if(N==5):
                    if(I1==0):theta=270/N
                if(N==7):
                    if(I1==0):theta=270/N
                if(N==9):
                    if(I1==0):theta=270/N
                XCC=XC+SRR*0.9*math.cos(theta*degs)
                YCC=YC+SRR*0.9*math.sin(theta*degs)
                XCC2=XC+SRR*1.2*math.cos(theta*degs)
                YCC2=YC+SRR*1.2*math.sin(theta*degs)
                XCCC=XC+SRR*1.1*math.cos((theta+ 23)*degs)
                YCCC=YC+SRR*1.1*math.sin((theta+ 23)*degs)
 #               dc.DrawLine(XC,YC,XCC,YCC)
#                dc.SetPen( wxPen("RED",PENS) )
               # dc.DrawLine(XC,YC,XCCC,YCCC)
                #dc.DrawLine(XCC,YCC,XCCCC,YCCCC)
                pts.append((XCC,YCC))
                pts.append((XCC2,YCC2))
                pts.append((XCCC,YCCC))
                MaBrush=wxBrush("BLACK",wxSOLID)
                dc.SetBrush(MaBrush)
                dc.DrawPolygon(pts)
                dc.SetPen(wxPen("BLACK",1))

            #Now draw arrows:  Make this easy--arrows on the edges

            if(N==3):SRR=3.5*RAD-(10-N)*1
            if(N==4):SRR=3.85*RAD
            if(N==5):SRR=4.1*RAD
            if(N==6):SRR=4.3*RAD
            if(N==7):SRR=4.3*RAD
            if(N==8):SRR=4.4*RAD
            if(N==9):SRR=4.4*RAD
            if(N==10):SRR=4.45*RAD
            theta = 180/N
            for I1 in range(N):
                pts=[]
                dc.SetPen( wxPen("BLACK",1) )
                theta=theta + 360/N
                if(N==3):
                   if(I1==0):theta=270/N
                if(N==5):
                    if(I1==0):theta=90/N
                if(N==6):
                    if(I1==0):theta=0
                if(N==7):
                    if(I1==0):theta=270/N
                if(N==9):
                    if(I1==0):theta=45/N
                if(N==10):
                    if(I1==0):theta=45/N
                XCC=XC+SRR*1.05*math.cos(theta*degs)
                YCC=YC+SRR*1.05*math.sin(theta*degs)
                XCC2=XC+SRR*1.15*math.cos(theta*degs)
                YCC2=YC+SRR*1.15*math.sin(theta*degs)
                XCCC=XC+SRR*1.1*math.cos((theta+ 13-N*0.5)*degs)
                YCCC=YC+SRR*1.1*math.sin((theta+ 13-N*0.5)*degs)
#                dc.DrawLine(XC,YC,XCC,YCC)
#                dc.SetPen( wxPen("RED",PENS) )
               # dc.DrawLine(XC,YC,XCCC,YCCC)
                #dc.DrawLine(XCC,YCC,XCCCC,YCCCC)
                pts.append((XCC,YCC))
                pts.append((XCC2,YCC2))
                pts.append((XCCC,YCCC))
                MaBrush=wxBrush("BLACK",wxSOLID)
                dc.SetBrush(MaBrush)
                dc.DrawPolygon(pts)
                dc.SetPen(wxPen("BLACK",1))


                
        if(self.TYPE=='Linear'):
            N = N -1
            CAP(M,MY,XCENT,YCENT,RAD,dc,self)
            XGEN(1,XCENT,YCENT,RAD,dc,self,event=None)
            XGEN(0,XCENT + M*RAD,YCENT,RAD,dc,self,event=None)
            OFF=self.FONTY
#            OFF=10
            font = wxFont(OFF*2,wxSWISS,wxNORMAL,wxBOLD)
            dc.SetFont(font)
            for I1 in range(N):
                UNSTABLE(XCENT+2*RAD +6*(I1)*RAD,YCENT-RAD,2*RAD,dc,self)  #Top Left corner, x y extents
                if (I1>0):GEN(XCENT+6*I1*RAD,YCENT,RAD,dc,self,event=None)
                if(ALPHA<1):
                    if(I1==0):dc.DrawText("a",XCENT-4+3*RAD+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==1):dc.DrawText("b",XCENT-4+3*RAD+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==2):dc.DrawText("c",XCENT-4+3*RAD+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==3):dc.DrawText("d",XCENT-4+3*RAD+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==4):dc.DrawText("e",XCENT-4+3*RAD+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==5):dc.DrawText("f",XCENT-4+3*RAD+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==6):dc.DrawText("g",XCENT-4+3*RAD+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==7):dc.DrawText("h",XCENT-4+3*RAD+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==8):dc.DrawText("i",XCENT-4+3*RAD+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==9):dc.DrawText("j",XCENT-4+3*RAD+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==10):dc.DrawText("k",XCENT-4+3*RAD+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==0):dc.DrawText("A",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==1):dc.DrawText("B",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==2):dc.DrawText("C",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==3):dc.DrawText("D",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==4):dc.DrawText("E",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==5):dc.DrawText("F",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==6):dc.DrawText("G",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==7):dc.DrawText("H",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==8):dc.DrawText("I",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==9):dc.DrawText("J",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==10):dc.DrawText("K",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8)                
                if(ALPHA<1):
                    if(I1==N-1):  #To catch the last whole
                        if(I1==0):dc.DrawText("B",XCENT-4+6*(N)*RAD-OFF/2,YCENT-OFF-8)
                        if(I1==1):dc.DrawText("C",XCENT-4+6*(N)*RAD-OFF/2,YCENT-OFF-8)
                        if(I1==2):dc.DrawText("D",XCENT-4+6*(N)*RAD-OFF/2,YCENT-OFF-8)
                        if(I1==3):dc.DrawText("E",XCENT-4+6*(N)*RAD-OFF/2,YCENT-OFF-8)
                        if(I1==4):dc.DrawText("F",XCENT-4+6*(N)*RAD-OFF/2,YCENT-OFF-8)
                        if(I1==5):dc.DrawText("G",XCENT-4+6*(N)*RAD-OFF/2,YCENT-OFF-8)
                        if(I1==6):dc.DrawText("H",XCENT-4+6*(N)*RAD-OFF/2,YCENT-OFF-8)
                        if(I1==7):dc.DrawText("I",XCENT-4+6*(N)*RAD-OFF/2,YCENT-OFF-8)
                        if(I1==8):dc.DrawText("J",XCENT-4+6*(N)*RAD-OFF/2,YCENT-OFF-8)
                        if(I1==9):dc.DrawText("K",XCENT-4+6*(N)*RAD-OFF/2,YCENT-OFF-8)
                if(NUMBER<1):
                    if(I1==0):dc.DrawText("1",XCENT-4+6*I1*RAD-2.5*RAD-OFF/2,YCENT-OFF-8)
                    if(I1==1):
                        dc.DrawText("2",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8 - 2.5*RAD)
                        dc.DrawText(str((I1+1)+2*(N-(I1+1))+2),XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8 + 2.5*RAD)
                    if(I1==2):
                        dc.DrawText("3",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8-2.5*RAD)
                        dc.DrawText(str((I1+1)+2*(N-(I1+1))+2),XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8 + 2.5*RAD)
                    if(I1==3):
                        dc.DrawText("4",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8-2.5*RAD)
                        dc.DrawText(str((I1+1)+2*(N-(I1+1))+2),XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8 + 2.5*RAD)
                    if(I1==4):
                        dc.DrawText("5",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8-2.5*RAD)
                        dc.DrawText(str((I1+1)+2*(N-(I1+1))+2),XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8 + 2.5*RAD)
                    if(I1==5):
                        dc.DrawText("6",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8-2.5*RAD)
                        dc.DrawText(str((I1+1)+2*(N-(I1+1))+2),XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8 + 2.5*RAD)
                    if(I1==6):
                        dc.DrawText("7",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8-2.5*RAD)
                        dc.DrawText(str((I1+1)+2*(N-(I1+1))+2),XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8 + 2.5*RAD)
                    if(I1==7):
                        dc.DrawText("8",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8-2.5*RAD)
                        dc.DrawText(str((I1+1)+2*(N-(I1+1))+2),XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8 + 2.5*RAD)
                    if(I1==8):
                        dc.DrawText("9",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8-2.5*RAD)
                        dc.DrawText(str((I1+1)+2*(N-(I1+1))+2),XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8 + 2.5*RAD)
                    if(I1==9):
                        dc.DrawText("10",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8-2.5*RAD)
                        dc.DrawText(str((I1+1)+2*(N-(I1+1))+2),XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8 + 2.5*RAD)
                    if(I1==10):
                        dc.DrawText("11",XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8-2.5*RAD)
                        dc.DrawText(str((I1+1)+2*(N-(I1+1))+2),XCENT-4+6*I1*RAD-OFF/2,YCENT-OFF-8 + 2.5*RAD)
                if(NUMBER<1):
                    if(I1==N-1):  #To catch the last whole
                        if(I1==1):dc.DrawText(str(N+1),XCENT-4+6*(N)*RAD-OFF/2+2.5*RAD,YCENT-OFF-8)
                        if(I1==2):dc.DrawText(str(N+1),XCENT-4+6*(N)*RAD-OFF/2+2.5*RAD,YCENT-OFF-8)
                        if(I1==3):dc.DrawText(str(N+1),XCENT-4+6*(N)*RAD-OFF/2+2.5*RAD,YCENT-OFF-8)
                        if(I1==4):dc.DrawText(str(N+1),XCENT-4+6*(N)*RAD-OFF/2+2.5*RAD,YCENT-OFF-8)
                        if(I1==5):dc.DrawText(str(N+1),XCENT-4+6*(N)*RAD-OFF/2+2.5*RAD,YCENT-OFF-8)
                        if(I1==6):dc.DrawText(str(N+1),XCENT-4+6*(N)*RAD-OFF/2+2.5*RAD,YCENT-OFF-8)
                        if(I1==7):dc.DrawText(str(N+1),XCENT-4+6*(N)*RAD-OFF/2+2.5*RAD,YCENT-OFF-8)
                        if(I1==8):dc.DrawText(str(N+1),XCENT-4+6*(N)*RAD-OFF/2+2.5*RAD,YCENT-OFF-8)
                        if(I1==9):dc.DrawText(str(N+1),XCENT-4+6*(N)*RAD-OFF/2+2.5*RAD,YCENT-OFF-8)
                    
                if(N==1):dc.DrawText('2',XCENT-4+6*(N)*RAD-OFF/2+2.5*RAD,YCENT-OFF-8)
                LARROW(XCENT+3*RAD+6*(I1)*RAD-RAD/ARDIV,YCENT+RAD,dc,self)
                RARROW(XCENT+3*RAD+6*(I1)*RAD-RAD/ARDIV,YCENT-RAD,dc,self)
                UARROW(XCENT+2*RAD+6*(I1)*RAD,YCENT,dc,self)
                DARROW(XCENT+4*RAD+6*(I1)*RAD,YCENT,dc,self)
                EDGE(XCENT+6*I1*RAD,YCENT,dc,self)
                RARROW(XCENT+3*RAD+6*I1*RAD-RAD/ARDIV,YCENT-2*RAD,dc,self)
                LARROW(XCENT+3*RAD+6*I1*RAD-RAD/ARDIV,YCENT+2*RAD,dc,self)
                
#FUNCTIONS_____________________________________________________

def CAP(M,MY,X,Y,RADIUS,dc,self,event=None):  #THE SIDES
        dc.SetPen( wxPen("BLACK",PENS) )
        dc.DrawCircle(X,Y,2*RADIUS)
        dc.DrawCircle(X+M*RADIUS,Y,2*RADIUS)
        MaBrush=wxBrush("WHITE",wxSOLID)
        dc.SetPen(wxPen("WHITE",1))
        dc.SetBrush(MaBrush)
        dc.DrawRectangle(X, Y-2*RADIUS, M*RADIUS,MY*RADIUS);
def XGEN(P,X,Y,RADIUS,dc,self,event=None):   #THE OUTER HOLES
        dc.SetPen( wxPen("BLACK",PENS))
        dc.DrawCircle(X,Y,RADIUS)
        if(P==1):dc.DrawLine(X-2*RADIUS,Y,X-RADIUS,Y)
        if(P==0):dc.DrawLine(X+2*RADIUS,Y,X+RAD,Y)
def GEN(X,Y,RADIUS,dc,self,event=None):   #THE OUTER HOLES
        dc.SetPen( wxPen("BLACK",PENS))
        dc.DrawCircle(X,Y,RADIUS)
        dc.DrawLine(X,Y-RADIUS,X,Y-2*RADIUS)
        dc.DrawLine(X,Y+RADIUS,X,Y+2*RADIUS)
def UNSTABLE(X,Y,EX,dc,self,event=None):     #THE UNSTABLE REGIONS
        dc.SetPen( wxPen("BLACK",APENS))
        dc.DrawRectangle(X,Y,EX,EX)          
def EDGE(X,Y,dc,self, event=None ):         #THE TOP/BOTTOM EDGES
        dc.SetPen( wxPen("BLACK",PENS))
         #DRAW TOP/BOTTOM CONTINUENCES TO END
        dc.DrawLine(X,Y-2*RAD,X+6*RAD,Y-2*RAD)
        dc.DrawLine(X,Y+2*RAD,X+6*RAD,Y+2*RAD)
        dc.SetPen( wxPen("BLACK",APENS))
def UARROW(X,Y,dc,self,event=None):         #ARROW CRAP
        dc.SetPen( wxPen("BLACK",APENS))
        dc.DrawLine(X-RAD/ARDIV,Y,X+RAD/ARDIV,Y)
        dc.DrawLine(X+RAD/ARDIV,Y,X,Y+ARXMULT*RAD/ARDIV)
        dc.DrawLine(X,Y+ARXMULT*RAD/ARDIV,X-RAD/ARDIV,Y)
def DARROW(X,Y,dc,self,event=None):
        dc.SetPen( wxPen("BLACK",APENS))
        dc.DrawLine(X-RAD/ARDIV,Y,X+RAD/ARDIV,Y)
        dc.DrawLine(X+RAD/ARDIV,Y,X,Y-ARXMULT*RAD/ARDIV)
        dc.DrawLine(X-RAD/ARDIV,Y,X,Y-ARXMULT*RAD/ARDIV)
def RARROW(X,Y,dc,self,event=None):
        #DRAW SOME ARROWS HALFWAY THROUGH
        dc.SetPen( wxPen("BLACK",APENS))
        dc.DrawLine(X,Y+RAD/ARDIV,X+ARXMULT*RAD/ARDIV,Y)
        dc.DrawLine(X+ARXMULT*RAD/ARDIV,Y,X,Y-RAD/ARDIV)
        dc.DrawLine(X,Y-RAD/ARDIV,X,Y+RAD/ARDIV)
def LARROW(X,Y,dc,self,event=None):
        #bottom as well
        dc.SetPen( wxPen("BLACK",APENS))
        dc.DrawLine(X+ARXMULT*RAD/ARDIV,Y+RAD/ARDIV,X+ARXMULT*RAD/ARDIV,Y-RAD/ARDIV)
        dc.DrawLine(X+ARXMULT*RAD/ARDIV,Y-RAD/ARDIV,X,Y)
        dc.DrawLine(X+ARXMULT*RAD/ARDIV,Y+RAD/ARDIV,X,Y)
def SAVE(self,event=None):  #SAVE ME
        context = wxClientDC( self ) 
        memory = wxMemoryDC( ) 
 #       x,y = self.GetClientSizeTuple() 
  #      bitmap = wxEmptyBitmap( x,y, -1 ) 
   #     memory.SelectObject( bitmap ) 
    #    memory.Blit( 0,0,x,y, context, 0,0) 
     #   memory.SelectObject( wxNullBitmap) 
        #bitmap.SaveFile( "test.bmp", wxBITMAP_TYPE_BMP ) 
      #  bitmap.SaveFile( "output.gif", wxBITMAP_TYPE_GIF )    

class App(wxApp):
    def OnInit(self):
        frame=ButtonFrame()
        frame.Show(true)
        return true
    
app=App(0)
app.MainLoop()
        



